=== modified file 'rules/convert/buffer_definitions.rules'
--- old/rules/convert/buffer_definitions.rules	2022-04-26 13:04:51 +0000
+++ new/rules/convert/buffer_definitions.rules	2022-05-12 15:24:44 +0000
@@ -4,7 +4,7 @@
 ** Module   : buffer_definitions.rules
 ** Abstract : converts implicit and explicit buffer definitions
 **
-** Copyright (c) 2004-2021, Golden Code Development Corporation.
+** Copyright (c) 2004-2022, Golden Code Development Corporation.
 **
 ** _#_ _I_ __Date__ __JPRM__ ____________________________Description_____________________________
 ** 001 GES 20051005   @22993 First version which converts Progress
@@ -179,6 +179,7 @@
 **     CA  20220208          External programs can have buffer parameters, but only for permanent tables, and
 **                           these need to be promoted.
 **     CA  20220426          Added RCODE-INFO:TABLE-LIST conversion support.
+**     GES 20220502          Reworked TableParameter to use subclasses.
 */
 -->
 
@@ -304,6 +305,7 @@
    <variable name="dbAliases"     type="java.util.Set" />
    <variable name="tableList"     type="java.util.Set" />
    <variable name="iter"          type="java.util.Iterator" />
+   <variable name="usesSubclass"     type="java.lang.Boolean" />
    
    <!-- functions "depot_stub" and "buffer_open_scope_anchor" moved to common-convert.rules. -->
    <include name="convert/common-convert" />
@@ -518,21 +520,29 @@
                         <action>bufjname = sprintf("%s.get()", bufjname)</action>
                      </rule>
                      
-                     <rule>parent.parent.type == prog.define_parameter
-                        <action>parmtype = #(long) parent.parent.getChildAt(0).type</action>
-                        <action on="false">
-                           parmtype = #(long) parent.parent.getAnnotation("parmtype")
-                        </action>
-                     </rule>
-                     
-                     <rule>parmtype == prog.kw_input or parmtype == prog.kw_in_out
-                        <action>parmin = "BOOL_TRUE"</action>
-                        <action on="false">parmin = "BOOL_FALSE"</action>
-                     </rule>
-                     
-                     <rule>parmtype == prog.kw_output or parmtype == prog.kw_in_out
-                        <action>parmout = "BOOL_TRUE"</action>
-                        <action on="false">parmout = "BOOL_FALSE"</action>
+                     <!-- functions and procedures use the base class TableParameter, OO methods use
+                          a TableParameter subclass; the subclass cases use simpler forms below -->
+                     <action>
+                        usesSubclass = (parent.parent.type == prog.parameter    and
+                                        parent.parent.isAnnotation("isOO")      and
+                                        #(java.lang.Boolean) parent.parent.getAnnotation("isOO"))
+                     </action>
+                     
+                     <rule>!usesSubclass
+                        <rule>parent.parent.type == prog.define_parameter
+                           <action>parmtype = #(long) parent.parent.getChildAt(0).type</action>
+                           <action on="false">
+                              parmtype = #(long) parent.parent.getAnnotation("parmtype")
+                           </action>
+                        </rule>
+                        <rule>parmtype == prog.kw_input or parmtype == prog.kw_in_out
+                           <action>parmin = "BOOL_TRUE"</action>
+                           <action on="false">parmin = "BOOL_FALSE"</action>
+                        </rule>
+                        <rule>parmtype == prog.kw_output or parmtype == prog.kw_in_out
+                           <action>parmout = "BOOL_TRUE"</action>
+                           <action on="false">parmout = "BOOL_FALSE"</action>
+                        </rule>
                      </rule>
                      <!-- the second argument to TemporaryBuffer.associate is the destination DMO;
                           if it has the same name as the first argument (the table parameter),
@@ -540,13 +550,21 @@
                      <rule>getNoteBoolean("qualify-outer")
                         <action>bufjname = sprintf("%s.this.%s", baseClass, bufjname)</action>
                      </rule>
-                     <action>
-                        lastthparam = tw.graft("associate_temp_tables", null, promid,
-                                               "javaname1", javaname,
-                                               "javaname2", bufjname,
-                                               "input",     parmin,
-                                               "output",    parmout)
-                     </action>
+                     
+                     <rule>usesSubclass
+                        <action>
+                           lastthparam = tw.graft("associate_temp_tables", null, promid,
+                                                  "javaname1", javaname,
+                                                  "javaname2", bufjname)
+                        </action>
+                        <action on="false">
+                           lastthparam = tw.graft("associate_temp_tables_full", null, promid,
+                                                  "javaname1", javaname,
+                                                  "javaname2", bufjname,
+                                                  "input",     parmin,
+                                                  "output",    parmout)
+                        </action>
+                     </rule>
                      <action>evalLib("setPassingModes", copy.parent.parent, lastthparam)</action>
                      
                      <rule on="false">true
@@ -1120,18 +1138,28 @@
                javaname = #(java.lang.String) parent.getAnnotation("javaname")
             </action>
          </rule>
+
+         <!-- functions and procedures use the base class TableParameter, OO methods use
+              a TableParameter subclass; the subclass cases use simpler forms below -->
+         <action>
+            usesSubclass = (parent.type == prog.parameter    and
+                            parent.isAnnotation("isOO")      and
+                            #(java.lang.Boolean) parent.getAnnotation("isOO"))
+         </action>
          
-         <rule>parent.type == prog.define_parameter
-            <action>parmtype = #(long) parent.getChildAt(0).type</action>
-            <action on="false">parmtype = #(long) parent.getAnnotation("parmtype")</action>
-         </rule>
-         <rule>parmtype == prog.kw_input or parmtype == prog.kw_in_out
-            <action>parmin = "BOOL_TRUE"</action>
-            <action on="false">parmin = "BOOL_FALSE"</action>
-         </rule>
-         <rule>parmtype == prog.kw_output or parmtype == prog.kw_in_out
-            <action>parmout = "BOOL_TRUE"</action>
-            <action on="false">parmout = "BOOL_FALSE"</action>
+         <rule>!usesSubclass         
+            <rule>parent.type == prog.define_parameter
+               <action>parmtype = #(long) parent.getChildAt(0).type</action>
+               <action on="false">parmtype = #(long) parent.getAnnotation("parmtype")</action>
+            </rule>
+            <rule>parmtype == prog.kw_input or parmtype == prog.kw_in_out
+               <action>parmin = "BOOL_TRUE"</action>
+               <action on="false">parmin = "BOOL_FALSE"</action>
+            </rule>
+            <rule>parmtype == prog.kw_output or parmtype == prog.kw_in_out
+               <action>parmout = "BOOL_TRUE"</action>
+               <action on="false">parmout = "BOOL_FALSE"</action>
+            </rule>
          </rule>
          <rule>lastthparam == null
             <action>ref2 = getAst(promid)</action>
@@ -1140,13 +1168,22 @@
             <action on="false">ref2 = lastthparam.parent</action>
             <action on="false">idx = lastthparam.indexPos + 1</action>
          </rule>
-         <action>
-            lastthparam = tw.graftAt("create_dynamic_tt", null, ref2, idx,
-                                     "javaname1", sprintf("_%s", javaname),
-                                     "javaname2", javaname,
-                                     "input", parmin,
-                                     "output", parmout)
-         </action>
+         
+         <rule>usesSubclass
+            <action>
+               lastthparam = tw.graftAt("create_dynamic_tt", null, ref2, idx,
+                                        "javaname1", sprintf("_%s", javaname),
+                                        "javaname2", javaname)
+            </action>
+            <action on="false">
+               lastthparam = tw.graftAt("create_dynamic_tt_full", null, ref2, idx,
+                                        "javaname1", sprintf("_%s", javaname),
+                                        "javaname2", javaname,
+                                        "input", parmin,
+                                        "output", parmout)
+            </action>
+         </rule>
+         
          <action>evalLib("setPassingModes", copy.parent, lastthparam)</action>
          
          <action>createImport("com.goldencode.p2j.persist.*")</action>

=== modified file 'rules/convert/common-convert.rules'
--- old/rules/convert/common-convert.rules	2021-12-23 02:03:54 +0000
+++ new/rules/convert/common-convert.rules	2022-05-12 15:03:49 +0000
@@ -5,17 +5,18 @@
 ** Module   : common-convert.rules
 ** Abstract : library of callable specific functions/rules in the code conversion iteration.
 **
-** Copyright (c) 2005-2020, Golden Code Development Corporation.
+** Copyright (c) 2005-2021, Golden Code Development Corporation.
 **
-** _#_ _I_ __Date__ ________________________________ Description _________________________________
+** _#_ _I_ __Date__ _____________________________________ Description ______________________________________
 ** 001 OM  20131128 Initial commit.
 ** 002 VIG 20160624 Added function "collect_ui_strings".
 ** 003 GES 20181217 Added a comment.
 ** 004 OM  20190403 Moved in buffer_open_scope_anchor from buffer_definitions.rules.
 ** 005 OM  20190523 Added setPassingModes() and add_bool_param() functions.
 ** 006 CA  20200412 Added incremental conversion support.
-** 007 CA  20200503 ParameterOption enums are qualified and not imported, as it collides 
-**                  character.valueOf with.
+** 007 CA  20200503 ParameterOption enums are qualified and not imported, as it collides with
+**                  character.valueOf.
+** 008 GES 20210430 Moved append flag from an unconditional boolean flag to a ParameterOption enum.
 */
 -->
 
@@ -220,7 +221,7 @@
       </function>
       
       <!-- optionally adds parameter passing mode for complex data types to target JAST method
-           call node: APPEND as a boolean, BY-VALUE, BY-REFERENCE and BIND as excluding enum.
+           call node: APPEND, BY-VALUE, BY-REFERENCE or BIND as mutually exclusive enum;
            can't import static, as enum's valueOf conflicts with character valueOf -->
       <function name="setPassingModes">
          <parameter name="source"  type="com.goldencode.ast.Aast" />
@@ -237,9 +238,10 @@
          <rule>isBind = source.isAnnotation("tt_ds_bind")</rule>
          
          <rule>isAppend or isByVal or isBind or isByRef
-            <!-- add APPEND flag regardless of other flags -->
-            <action>evalLib("add_bool_param", target, isAppend)</action>
-            
+            <!-- add APPEND flag -->
+            <rule>isAppend
+               <action>createJavaAst(java.reference, "ParameterOption.APPEND", target)</action>
+            </rule>            
             <!-- add BY-VALUE flag -->
             <rule>isByVal
                <action>createJavaAst(java.reference, "ParameterOption.BY_VALUE", target)</action>

=== modified file 'rules/convert/database_references.rules'
--- old/rules/convert/database_references.rules	2022-05-14 17:02:52 +0000
+++ new/rules/convert/database_references.rules	2022-05-20 12:08:38 +0000
@@ -183,6 +183,7 @@
 **     CA  20220514          Added 'dynamic_set_parameter_last_argument' - this is required to properly
 **                           distinguish the parameter in a ParameterList:setParameter, as this OO method call
 **                           can have the INPUT/OUTPUT/INPUT-OUTPUT modes set.
+**     GES 20210519          Reworked table parameters to use subclasses of TableParameter.
 */
 -->
 
@@ -279,43 +280,44 @@
    </func-library>
    
    <!-- variables -->
-   <variable name="casttype"    type="java.lang.String" />
-   <variable name="javaname"    type="java.lang.String" />
-   <variable name="clsname"     type="java.lang.String" />
-   <variable name="txt"         type="java.lang.String" />
-   <variable name="methodtxt"   type="java.lang.String" />
-   <variable name="bufname"     type="java.lang.String" />
-   <variable name="wrapimp"     type="java.lang.Boolean" />
-   <variable name="finaltxt"    type="java.lang.String" />
-   <variable name="fieldtype"   type="java.lang.String" />
-   <variable name="partype"     type="java.lang.String" />
-   <variable name="methodtype"  type="java.lang.Integer" />
-   <variable name="idx"         type="java.lang.Integer" />
-   <variable name="astid"       type="java.lang.Long" />
-   <variable name="lastid"      type="java.lang.Long" />
-   <variable name="origid"      type="java.lang.Long" />
-   <variable name="deferid"     type="java.lang.Long" />
-   <variable name="paridx"      type="java.lang.Long" />
-   <variable name="builtin"     type="java.lang.Boolean" />
-   <variable name="inmsg"       type="java.lang.Boolean" />
-   <variable name="insetp"      type="java.lang.Boolean" />
-   <variable name="special"     type="java.lang.Boolean" />
-   <variable name="suppress"    type="java.lang.Boolean" />
-   <variable name="accessor"    type="java.lang.Boolean" />
-   <variable name="assign_back" type="java.lang.Boolean" />
-   <variable name="needs_value" type="java.lang.Boolean" />
-   <variable name="fieldrefimp" type="java.lang.Boolean" />
-   <variable name="inline"      type="java.lang.Boolean" />
-   <variable name="isAccum"     type="java.lang.Boolean" />
-   <variable name="ref"         type="com.goldencode.ast.Aast" />
-   <variable name="ref2"        type="com.goldencode.ast.Aast" />
-   <variable name="lref"        type="com.goldencode.ast.Aast" />
-   <variable name="lref2"       type="com.goldencode.ast.Aast" />
-   <variable name="parref"      type="com.goldencode.ast.Aast" />
-   <variable name="scopeRef"    type="com.goldencode.ast.Aast" />
-   <variable name="usedByExprs" type="java.util.Set" />
-   <variable name="is_extent"   type="java.lang.Boolean" />
-   <variable name="isTableHandle" type="java.lang.Boolean" />
+   <variable name="casttype"                    type="java.lang.String" />
+   <variable name="javaname"                    type="java.lang.String" />
+   <variable name="tabParmType"                 type="java.lang.String" />
+   <variable name="clsname"                     type="java.lang.String" />
+   <variable name="txt"                         type="java.lang.String" />
+   <variable name="methodtxt"                   type="java.lang.String" />
+   <variable name="bufname"                     type="java.lang.String" />
+   <variable name="wrapimp"                     type="java.lang.Boolean" />
+   <variable name="finaltxt"                    type="java.lang.String" />
+   <variable name="fieldtype"                   type="java.lang.String" />
+   <variable name="partype"                     type="java.lang.String" />
+   <variable name="methodtype"                  type="java.lang.Integer" />
+   <variable name="idx"                         type="java.lang.Integer" />
+   <variable name="astid"                       type="java.lang.Long" />
+   <variable name="lastid"                      type="java.lang.Long" />
+   <variable name="origid"                      type="java.lang.Long" />
+   <variable name="deferid"                     type="java.lang.Long" />
+   <variable name="paridx"                      type="java.lang.Long" />
+   <variable name="builtin"                     type="java.lang.Boolean" />
+   <variable name="inmsg"                       type="java.lang.Boolean" />
+   <variable name="insetp"                      type="java.lang.Boolean" />
+   <variable name="special"                     type="java.lang.Boolean" />
+   <variable name="suppress"                    type="java.lang.Boolean" />
+   <variable name="accessor"                    type="java.lang.Boolean" />
+   <variable name="assign_back"                 type="java.lang.Boolean" />
+   <variable name="needs_value"                 type="java.lang.Boolean" />
+   <variable name="fieldrefimp"                 type="java.lang.Boolean" />
+   <variable name="inline"                      type="java.lang.Boolean" />
+   <variable name="isAccum"                     type="java.lang.Boolean" />
+   <variable name="ref"                         type="com.goldencode.ast.Aast" />
+   <variable name="ref2"                        type="com.goldencode.ast.Aast" />
+   <variable name="lref"                        type="com.goldencode.ast.Aast" />
+   <variable name="lref2"                       type="com.goldencode.ast.Aast" />
+   <variable name="parref"                      type="com.goldencode.ast.Aast" />
+   <variable name="scopeRef"                    type="com.goldencode.ast.Aast" />
+   <variable name="usedByExprs"                 type="java.util.Set" />
+   <variable name="is_extent"                   type="java.lang.Boolean" />
+   <variable name="isTableHandle"               type="java.lang.Boolean" />
    <variable name="lval_of_embedded_assignment" type="java.lang.Boolean" />
    
    <!-- main processing (once per tree) -->
@@ -372,6 +374,12 @@
          <!-- dereference the Java name for the buffer -->
          <action>javaname = execLib("get_javaname", copy)</action>
          
+         <!-- lookup the TableParameter subclass that should be used, default to the base class if no
+              jtype annotation exists -->
+         <action>
+            tabParmType = execLib("read_jtype", copy, "TableParameter", "database_references 1")
+         </action>
+         
          <action>isTableHandle = false</action>
          <action>parref = parent.parent</action>
          <rule>(relativePath("COLON/KW_TEMP_TAB/TEMP_TABLE") or
@@ -387,7 +395,7 @@
          </rule>
 
          <!-- emit the buffer reference (or TableParameter if we pass a TABLE parameter to
-              procedure/function) -->
+              procedure/function, or TableParameter subclass if passed to an OO method) -->
          <rule>(relativePath("KW_TABLE/TEMP_TABLE") or
                 relativePath("KW_TABLE/BUFFER")     or
                 isTableHandle) and
@@ -412,8 +420,19 @@
                   <action>partype = parref.getAnnotation("typelist", paridx)</action>
                   <rule>partype == "TABLE-HANDLE"
                      <action>lref = getAst(closestPeerId)</action>
-                     <action>
-                        lref2 = createJavaAst(java.constructor, "TableParameter", lref.parent, lref.indexPos)
+                     <!-- lookup the TableParameter subclass that should be used, default to the base class
+                          if no jtype annotation exists -->
+                     <action>
+                        tabParmType = #(java.lang.String) execLib("read_jtype",
+                                                                  ref2,
+                                                                  "TableParameter",
+                                                                  "database_references 2")
+                     </action>
+                     <action>
+                        lref2 = createJavaAst(java.constructor,
+                                              tabParmType,
+                                              lref.parent,
+                                              lref.indexPos)
                      </action>
                      <action>lref.move(lref2, 0)</action>
                      <action>lastid = lref.id</action>
@@ -432,10 +451,14 @@
                <rule on="false">
                   ref.isAnnotation("static") and getReferenceNoteBoolean(ref.id, "static")
                   <action>
-                     ref = tw.graft("table_param_static", copy, closestPeerId, "javaname", javaname)
+                     ref = tw.graft("table_param_static", copy, closestPeerId,
+                                    "tab-parm-type", tabParmType,
+                                    "javaname", javaname)
                   </action>
                   <action on="false">
-                     ref = tw.graft("table_param", copy, closestPeerId, "javaname", javaname)
+                     ref = tw.graft("table_param", copy, closestPeerId,
+                                    "tab-parm-type", tabParmType,
+                                    "javaname", javaname)
                   </action>
                </rule>
             </rule>
@@ -1001,9 +1024,11 @@
                   
                   <!-- for wrapped fields we need to pass in the datatype class as 3rd param -->
                   <rule>assign_back
-                     <rule>isNote("classname")
-                        <!-- some cases for OO method arg requires classname override -->
-                        <action>fieldtype = getNoteString("classname")</action>
+                     <!-- OO fields use generics and that can be directly emitted as a class -->
+                     <rule>type == prog.field_class
+                        <!-- no cast to Class<object<? extends _BaseObject_>> is needed here to compile the
+                             result; if the cast is attempted it won't compile -->
+                        <action>fieldtype = "object"</action>
                      </rule>
                      
                      <action>

=== modified file 'rules/convert/datasets.rules'
--- old/rules/convert/datasets.rules	2022-05-03 18:14:41 +0000
+++ new/rules/convert/datasets.rules	2022-05-12 15:28:21 +0000
@@ -6,7 +6,7 @@
 **
 ** Copyright (c) 2019-2022, Golden Code Development Corporation.
 **
-** _#_ _I_ __Date__ _________________________________Description_________________________________
+** _#_ _I_ __Date__ _______________________________________Description_______________________________________
 ** 001 OM  20190327 First commit.
 ** 002 OM  20190305 Fixed DataSetParameter/dataset-handle issue.
 ** 003 CA  20190514 Fixed conversion of DATASET and DATA-SOURCE class members (access-mode and
@@ -20,7 +20,9 @@
 **                  APIs, as these modes are optional for function or OO method definitions.
 ** 006 CA  20200503 ParameterOption enums are qualified and not imported, as it collides 
 **                  character.valueOf with.
-** 067 CA  20220426 Fixed conversion of DATASET arguments at NEW or DYNAMIC-NEW.
+** 007 GES 20210506 Reworked emit of parameters/arguments to use subclasses of DataSetParameter. Removed
+**                  unnecessary boolean parameters to associate() and createDynamicDataSet().
+**     CA  20220426 Fixed conversion of DATASET arguments at NEW or DYNAMIC-NEW.
 */
 -->
 
@@ -99,6 +101,7 @@
    <variable name="parmtype"      type="java.lang.Long" />
    <variable name="javaName"      type="java.lang.String" />
    <variable name="thisName"      type="java.lang.String" />
+   <variable name="dsetParmType"  type="java.lang.String" />
    <variable name="toplvlref"     type="com.goldencode.ast.Aast" />
    <variable name="dsref"         type="com.goldencode.ast.Aast" />
    <variable name="ref"           type="com.goldencode.ast.Aast" />
@@ -135,9 +138,17 @@
                <action>lastid = #(long) execLib("get_parmroot", copy.getAncestor(2))</action>
                <action on="false">lastid = closestPeerId</action>
             </rule>
+            
+            <!-- lookup the DataSetParameter subclass that should be used, use the base class for
+                 functions or procedures (but we must use a subclass for OO methods) -->
             <action>
-               lastid = createJavaAst(java.reference_def, "DataSetParameter", lastid))
+               dsetParmType = execLib("read_jtype",
+                                      copy.parent.parent,
+                                      "DataSetParameter",
+                                      "datasets 1")
             </action>
+            
+            <action>lastid = createJavaAst(java.reference_def, dsetParmType, lastid))</action>
             <action>ref = getAst(lastid)</action>
             <action>ref.putAnnotation("name", getNoteString("javaname"))</action>
             <action>ref.putAnnotation("final", true)</action>
@@ -167,8 +178,10 @@
                   createJavaAst(java.reference, sprintf("%s.this", thisName), lastid)
                </action>
             </rule>
-            
+
             <action>ref2 = copy.parent.parent</action>
+            
+            <!-- procedures use the base class so we need the extra booleans -->
             <rule>ref2.type == prog.define_parameter
                <!-- add input flag -->
                <action>
@@ -183,8 +196,14 @@
                           ref2.getImmediateChild(prog.kw_output, null) != null)
                </action>
             </rule>
-            
-            <rule>ref2.type == prog.parameter
+               
+            <!-- functions use the base class so they also need the extra boolean parms but we must avoid
+                 the OO cases -->
+            <rule>
+               ref2.type == prog.parameter   and
+               ref2.isAnnotation("isOO")     and
+               !(#(java.lang.Boolean) ref2.getAnnotation("isOO"))
+               
                <action>parmtype = #(long) ref2.getAnnotation("parmtype")</action>
                
                <!-- add input flag -->
@@ -247,7 +266,8 @@
          </action>
          <action>createPeerAst(java.reference, sprintf("_%s", javaName), ref)</action>
          <action>createPeerAst(java.reference, javaName, ref)</action>
-         
+
+         <!-- procedures use the base class so we need the extra booleans -->
          <rule>parent.type == prog.define_parameter
             <!-- add input flag -->
             <action>
@@ -263,7 +283,13 @@
             </action>
          </rule>
          
-         <rule>parent.type == prog.parameter
+         <!-- functions use the base class so they also need the extra boolean parms but we must avoid
+              the OO cases -->
+         <rule>
+            parent.type == prog.parameter   and
+            parent.isAnnotation("isOO")     and
+            !(#(java.lang.Boolean) parent.getAnnotation("isOO"))
+            
             <action>parmtype = #(long) parent.getAnnotation("parmtype")</action>
 
             <!-- add input flag -->
@@ -295,7 +321,17 @@
                 copy.parent.type &lt; prog.end_oo_meth))                or
               (parent.type == prog.parameter and 
                evalLib("type_pair", parent.parent.parent, prog.func_class, prog.kw_new))
-            <action>createPeerAst(java.constructor, "DataSetParameter", closestPeerId)</action>
+               
+            <!-- lookup the DataSetParameter subclass that should be used, use the base class for
+                 functions or procedures (but we must use a subclass for OO methods) -->
+            <action>
+               dsetParmType = execLib("read_jtype",
+                                      copy,
+                                      "DataSetParameter",
+                                      "datasets 2")
+            </action>
+            
+            <action>createPeerAst(java.constructor, dsetParmType, closestPeerId)</action>
             <action>importPersist = true</action>
          </rule>
       </rule>

